require_relative "berichtsheft/settings"
require_relative "berichtsheft/employee"
require_relative "berichtsheft/parser"
require_relative "berichtsheft/activities"
require_relative "berichtsheft/document"

module Berichtsheft
  class Weekly
    def initialize(args)
      @csv_file = args[:csv_file]
      @save_to = args[:save_to]
      @first_name = args[:first_name]
      @last_name = args[:last_name]
      @department = args[:department]
      @id_for_week = args[:id_for_week]
      @template = args[:template]
    end

    def settings
      Berichtsheft::Settings.new(@id_for_week, @save_to)
    end

    def employee
      Berichtsheft::Employee.new(
        first_name: @first_name,
        last_name: @last_name,
        department: @department
      )
    end

    def parser
      Berichtsheft::CSVParser.new(@csv_file)
    end

    def activities
      Berichtsheft::Activities.new(parser.data, @id_for_week)
    end

    def document
      Berichtsheft::Document.new(employee, activities, settings)
    end

    def generate
      document.generate
    end
  end
end
