module Berichtsheft
  # Implements the CSV parser.
  class CSVParser
    attr_reader :data

    def initialize(csv_file)
      @data = read_file(csv_file)
    end

    def data
      @data
    end

    def read_file(csv_file)
      all_activities = []

      begin
        file = File.open(csv_file, "r")
        while line = file.gets
          all_activities.push parse_line(line)
        end
      rescue IOError => e
        puts e
      ensure
        file.close unless file.nil?
      end

      all_activities
    end

    # Expected values for each line:
    # date(YYYY-MM-DD),description,duration(HH-MM),id_for_week
    def parse_line(line)
      entity = line.force_encoding(Encoding::UTF_8).split(",")
      Hash[
        "date" => entity[0],
        "description" => entity[1],
        "duration" => entity[2],
        "id_for_week" => entity[3].to_i
      ]
    end
  end
end
