module Berichtsheft
  # Provides document specific information such as the resulting filename.
  class Settings
    # Provides the value for a workweek. The first week is the week, the
    # employee has started working for the company.
    attr_accessor :id_for_week

    # Provides the path to save the output file. The file paht should always
    # end with a slash. Example: '~/path/to/file/'
    attr_accessor :file_path

    # Working for over 4 years as an apprentice is implausible.
    def id_valid?(id_for_week)
      if id_for_week > 0 && id_for_week < 251
        return true
      else
        raise ArgumentError
      end
    end

    def initialize(id_for_week, file_path)
      @id_for_week = id_for_week if id_valid?(id_for_week)
      @file_path = file_path if File.directory?(file_path)
    end
  end
end
